#PBForms Created
'--------------------------------------------------------------------------------
#Compile Exe
'--------------------------------------------------------------------------------
' ** Includes **
'--------------------------------------------------------------------------------
#PBForms Begin Includes
#If Not %Def(%WINAPI)
#Include "WIN32API.INC"
#EndIf
#PBForms End Includes
%IsXP = %FALSE
#Include "cards.inc"
'--------------------------------------------------------------------------------
'--------------------------------------------------------------------------------
' ** Constants **
'--------------------------------------------------------------------------------
#PBForms Begin Constants
%IDD_DIALOG1 = 101
%IDC_BUTTON1 = 1001
%IDC_BUTTON2 = 1002
%IDC_cmdPlay = 1001
%IDC_cmdPass = 1002
%IDR_MENU1 = 102
%IDM_FileNew = 1003
%IDM_FileOptions = 1004
%IDM_FileScore = 1005
%IDM_FileExit = 1006
%IDM_HelpRules = 1007
%IDM_HelpAbout = 1008

%IDD_frmScore = 103
%IDC_LABEL5 = 1013
%IDC_LABEL6 = 1014
%IDC_LABEL7 = 1015
%IDC_LABEL8 = 1016
%IDC_BUTTON3 = 1017

%IDD_frmNominate = 104
%IDC_OPTION1 = 1018
%IDC_OPTION2 = 1019
%IDC_OPTION3 = 1020
%IDC_OPTION4 = 1021
%IDC_BUTTON4 = 1022
%IDT_TIMER1 = 1050
%IDOK = 1

%IDD_frmOptions = 106
%IDC_LISTBOX1 = 1028
%IDC_COMBOBOX1 = 1029
%IDC_BUTTON6 = 1030
%IDC_BUTTON7 = 1031
%IDCANCEL = 2
%IDC_TEXTBOX1 = 1032
%IDC_TEXTBOX2 = 1033

%IDD_frmAbout = 107
%IDT_TIMER3 = 1035
%IDC_INFO = 1036
%IDC_IMAGEX6 = 1037
%IDC_LABELMEM = 1038
%IDC_LABELRES = 1039
%IDC_LABELNIC = 1040
%IDC_SLABELMEM = 1041
%IDC_SLABELRES = 1042
%IDR_ACCELERATOR1 = -1
#PBForms End Constants
'--------------------------------------------------------------------------------
%NumPlayers = 4 ' Standard 4 player game

%Deck = 0 ' Constants used in determining which card belongs to what in the bytCard array
%Player1 = 1
%Player2 = 2
%Player3 = 3
%Player4 = 4
%Discard = 5

%DeckX = 260 ' Midpoints for all of the players and deck locations
%DeckY = 200
%DiscardX = 340
%DiscardY = 200
%Player1XMid = 300
%Player1YMid = 335
%Player2XMid = 50
%Player2YMid = 200
%Player3XMid = 300
%Player3YMid = 65
%Player4XMid = 550
%Player4YMid = 200

%CardOffsetX = 15 ' Spacing between cards in a card stack
%CardOffsetY = 15

Global Player1CardX As Long ' What are the X and Y coordinates where each player's cards start to be placed?
Global Player1CardY As Long
Global Player2CardX As Long
Global Player2CardY As Long
Global Player3CardX As Long
Global Player3CardY As Long
Global Player4CardX As Long
Global Player4CardY As Long

Global Games As Long ' How many games have been played so far?
Global bytPlayerTurn As Byte ' Which player's turn is it?
Global bytCurrentCard As Byte ' What is the value of the current card played?
Global Discard As Long ' Which card is currently on the discard pile?
Global ShowCards As Long ' Should we be showing the computer players' cards or not?
Global GameOn As Long ' Is the game on, or not?
Global cWidth As Long ' Width of the standard cards from Cards32.DLL
Global cHeight As Long ' Height of the standard cards from Cards32.DLL
Global bytCard() As Byte ' Describes the owner of each card in the deck
Global bytInvert() As Byte ' Determines which card(s) are currently highlighted (inverted)
Global deck() As Long ' The randomly shuffled deck of cards
Global NumCards() As Long ' How many cards do the players currently have?
Global BackFace As Long ' What deck art are we using?
Global hDlgMain As Dword
Global hMenu As Dword
Global MustDraw As Long
Global hHook As Long


'--------------------------------------------------------------------------------
' ** Declarations **
'--------------------------------------------------------------------------------
Declare Function AttachMENU1(ByVal hDlg As Dword) As Dword
Declare CallBack Function ShowDIALOG1Proc()
Declare CallBack Function ShowfrmScoreProc()
Declare Function ShowDIALOG1(ByVal hParent As Dword) As Long
Declare Function ShowfrmScore(ByVal hParent As Dword) As Long
Declare Function ShowfrmNominate(ByVal hParent As Dword) As Long
Declare Function ShowfrmOptions(ByVal hParent As Dword) As Long
Declare Function ShowDialog_About(ByVal hParent As Dword) As Long
Declare Function AttachACCELERATOR1(ByVal hDlg As Dword) As Dword
Declare Function ValueCard(Card As Long) As Long
Declare Function ValidPlay(Card As Long) As Long
Declare Function GetSuit(Card As Long) As Byte
Declare Function OrderSuits(CardNum As Long) As Long
Declare Sub AddScores()
Declare Sub TakeTurn(bytPlayer As Byte)
Declare Sub Deal()
Declare Sub ResetGame()
Declare Sub PlayCard(Card As Long)
Declare Sub PassTurn(bytPlayer As Byte)
Declare Function GetFreeResources Lib "RSRC32.DLL" Alias "_MyGetFreeSystemResources32@4" (ByVal WhichResource As Long) As Long

#PBForms Declarations
'--------------------------------------------------------------------------------

Function PBMain()
ShowDIALOG1 %HWND_DESKTOP
End Function
'--------------------------------------------------------------------------------

'--------------------------------------------------------------------------------
' ** Menus **
'--------------------------------------------------------------------------------
Function AttachMENU1(ByVal hDlg As Dword) As Dword
#PBForms Begin Menu %IDR_MENU1->%IDD_DIALOG1
Local hPopUp1 As Dword

Menu New Bar To hMenu
Menu New PopUp To hPopUp1
Menu Add PopUp, hMenu, "&File", hPopUp1, %MF_ENABLED
Menu Add String, hPopUp1, "&New Game" + $Tab + "F2", %IDM_FileNew, %MF_ENABLED
Menu Add String, hPopUp1, "&Options...", %IDM_FileOptions, %MF_ENABLED
Menu Add String, hPopUp1, "&Score...", %IDM_FileScore, %MF_ENABLED
Menu Add String, hPopUp1, "-", 0, 0
Menu Add String, hPopUp1, "E&xit" + $Tab + "Alt+F4", %IDM_FileExit, %MF_ENABLED
Menu New PopUp To hPopUp1
Menu Add PopUp, hMenu, "&Help", hPopUp1, %MF_ENABLED
Menu Add String, hPopUp1, "How to &Play...", %IDM_HelpRules, %MF_ENABLED
Menu Add String, hPopUp1, "&About Crazy Eights", %IDM_HelpAbout, _
%MF_ENABLED

Menu Attach hMenu, hDlg

#PBForms End Menu
Function = hMenu
End Function
'--------------------------------------------------------------------------------

Function InitComboBox(ByVal hDlg As Dword, ByVal lID As Long, ByVal lCount As Long) As Long
Local i As Long
Dim BN(12) As Local String

#If %IsXP
BN(0) = "CrossHatch" : BN(1) = "Clouds" : BN(2) = "Vstreak" : BN(3) = "Fish"
BN(4) = "Frog" : BN(5) = "Rose" : BN(6) = "Island" : BN(7) = "Squares"
BN(8) = "Beads" : BN(9) = "Horizon" : BN(10) = "Spacesuit" : BN(11) = "Hbars"
BN(12) = "Racecars"
#Else
BN(0) = "CrossHatch" : BN(1) = "Plaid" : BN(2) = "Weave" : BN(3) = "Robot"
BN(4) = "Roses" : BN(5) = "IvyBlack" : BN(6) = "IvyBlue" : BN(7) = "FishCyan"
BN(8) = "FishBlue" : BN(9) = "Shell" : BN(10) = "Castle" : BN(11) = "Beach"
BN(12) = "CardHand"
#EndIf

For i = 0 To UBound(BN)
ComboBox Add hDlg, lID, BN(i)
Next
End Function
'--------------------------------------------------------------------------------

Function MBProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
' Centers MessageBox dialog within CLIENT area of our dialog, rather than the desktop.
' Monitors HCBT_CREATEWND rather than HCBT_ACTIVATE to prevent interference with the
' 'SnapTo default button' mouse pointer option.

If nCode = %HCBT_CREATEWND Then
Local rc As RECT, p As POINTAPI
Local cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr

cw = lParam ' Get pointer to CBT_CREATEWND struct so we can...
cst = @cw.lpcs ' get a pointer to the CREATESTRUCT struct
GetClientRect @cst.hwndParent, rc
ClientToScreen @cst.hwndParent, p
@cst.x = (rc.nRight - @cst.cx) \ 2 + p.x
@cst.y = (rc.nBottom - @cst.cy) \ 2 + p.y
UnhookWindowsHookEx hHook
End If
End Function
'--------------------------------------------------------------------------------

Sub wMsgBox(txt As String, title As String)
' A well-behaved message box

hHook = SetWindowsHookEx(%WH_CBT, CodePtr(MBProc), GetModuleHandle(ByVal %NULL), GetCurrentThreadId)
Messagebox hDlgMain, ByVal StrPtr(txt), ByVal StrPtr(title), %MB_OK Or %MB_APPLMODAL Or %MB_DEFBUTTON1
End Sub
'--------------------------------------------------------------------------------

Sub Repaint()
InvalidateRect hDlgMain, ByVal %NULL, %FALSE
UpdateWindow hDlgMain
End Sub
'--------------------------------------------------------------------------------

Function GreatestSuit() As Long
' Returns the suit in the players hand containing the greatest # of cards
Local i As Long, Rslt As Long
Dim Suits(3) As Local Long

For i = 0 To UBound(bytCard)
If bytCard(i) = bytPlayerTurn Then
' Eights don't count
If i <> 7 And i <> 20 And i <> 33 And i <> 46 Then Incr Suits(GetSuit(i))
End If
Next 'i
Rslt = Max&(Suits(0), Suits(1), Suits(2), Suits(3))
Array Scan Suits(), = Rslt, To Rslt
Function = Rslt - 1
End Function
'--------------------------------------------------------------------------------

Sub Shuffle(deck() As Long)
' Shuffles the deck with no requirement for duplicate checking
Local i As Long, j As Long
Dim dummy(UBound(deck)) As Local Single

' Shuffle once to randomize ordered deck. Then shuffle again.
For i = 0 To 1
Randomize
For j = 0 To UBound(deck) : dummy(j) = Rnd : Next 'j
Array Sort dummy(), TagArray deck()
Sleep Rnd(10)
Next 'i
End Sub
'--------------------------------------------------------------------------------

Function GetCard() As Long
Local Rslt As Long
Array Scan deck(), =>0, To Rslt
Decr Rslt
Function = deck(Rslt)
deck(Rslt) = -1 ' Tag card as 'removed from deck'
End Function
'--------------------------------------------------------------------------------

Sub PaintCards(hDC As Dword)
Local i As Long, aHeight As Long, aWidth As Long
Local strCaption As String
' For debug (or cheating):
'ShowCards = %TRUE

aHeight = cHeight / 2 : aWidth = cWidth / 2
'Set the current player label
strCaption = "Crazy Eights (Player:" & Str$(bytPlayerTurn) & " - Suit: "

' Determine the current suit text
Select Case bytCurrentSuit
Case %Clubs
strCaption = strCaption & "Clubs)"
Case %Diamonds
strCaption = strCaption & "Diamonds)"
Case %Hearts
strCaption = strCaption & "Hearts)"
Case %Spades
strCaption = strCaption & "Spades)"
Case %AnySuit
strCaption = strCaption & "Any)"
End Select 'bytCurrentSuit

'Set the form's caption
Dialog Set Text hDlgMain, strCaption

' Determine the starting X, Y for each player's cards
Player1CardX = %Player1XMid - (cWidth + %CardOffsetX * (NumCards(0) - 1)) / 2
Player1CardY = %Player1YMid - aHeight
Player3CardX = %Player3XMid - (cWidth + %CardOffsetX * (NumCards(2) - 1)) / 2
Player3CardY = %Player3YMid - aHeight
Player2CardX = %Player2XMid - aWidth
Player2CardY = %Player2YMid - (cHeight + %CardOffsetY * (NumCards(1) - 1)) / 2
Player4CardX = %Player4XMid - aWidth
Player4CardY = %Player4YMid - (cHeight + %CardOffsetY * (NumCards(3) - 1)) / 2

'Step through each card and display it
For i = 0 To UBound(bytCard)
' Check if a card back should be displayed for the deck pile.
' If not, the deck is empty.
If bytCard(i) = %Deck Then _
cdtDraw hDC, %DeckX - aWidth, %DeckY - aHeight, BackFace, %ordBacks, %White

' Determine which card is on the top of the discard pile
If Discard <> %NoCard Then _
cdtDraw hDC, %DiscardX - aWidth, %DiscardY - aHeight, OrderSuits(Discard), %ordFaces, %White

Select Case bytCard(i) ' Who does the card belong to?
Case %Player1
cdtDraw hDC, Player1CardX, Player1CardY, OrderSuits(i), bytInvert(i), %White
Player1CardX = Player1CardX + %CardOffsetX

Case %Player2
cdtDraw hDC, Player2CardX, Player2CardY, IIf&(ShowCards, OrderSuits(i), BackFace), _
IIf&(ShowCards, %ordFaces, %ordBacks), %White
Player2CardY = Player2CardY + %CardOffsetY

Case %Player3
cdtDraw hDC, Player3CardX, Player3CardY, IIf&(ShowCards, OrderSuits(i), BackFace), _
IIf&(ShowCards, %ordFaces, %ordBacks), %White
Player3CardX = Player3CardX + %CardOffsetX

Case %Player4
cdtDraw hDC, Player4CardX, Player4CardY, IIf&(ShowCards, OrderSuits(i), BackFace), _
IIf&(ShowCards, %ordFaces, %ordBacks), %White
Player4CardY = Player4CardY + %CardOffsetY
End Select 'bytCard(i)
Next 'i
End Sub
'--------------------------------------------------------------------------------

Function OrderSuits(CardNum As Long) As Long
' This function takes a card number and returns
' an index, effectively ordering all of
' the cards according to suit

Select Case CardNum
Case 0 To 12
Function = CardNum * 4 + %Clubs

Case 13 To 25
Function = ((CardNum - 13) * 4) + %Diamonds

Case 26 To 38
Function = ((CardNum - 26) * 4) + %Hearts

Case 39 To 51
Function = ((CardNum - 39) * 4) + %Spades
End Select 'CardNum
End Function
'--------------------------------------------------------------------------------

Function ValueCard(Card As Long) As Long
' Returns the point value of a card
' Eights are worth fifty
If Card = 7 Or Card = 20 Or Card = 33 Or Card = 46 Then
Function = 50
ElseIf Card Mod 13 > 9 Then ' Faces are worth 10
Function = 10
Else ' All others are worth face value
Function = (Card Mod 13) + 1
End If
End Function
'--------------------------------------------------------------------------------

Sub AddScores()
Local i As Long
' Add up the values of the cards left in losers' hands
For i = 0 To UBound(bytCard)
Select Case bytCard(i)
Case %Player1
Player1Score = Player1Score + ValueCard(i)

Case %Player2
Player2Score = Player2Score + ValueCard(i)

Case %Player3
Player3Score = Player3Score + ValueCard(i)

Case %Player4
Player4Score = Player4Score + ValueCard(i)
End Select 'bytCard(i)
Next
End Sub
'--------------------------------------------------------------------------------

Function ValidPlay(Card As Long) As Long
' Check if a given card is a valid play given the current game state

Function = %True
' If any card at all can be played or card is the right suit...
If bytCurrentSuit = %AnySuit Or bytCurrentSuit = GetSuit(Card) Then
' If the card selected is one of the eights...
ElseIf Card = 7 Or Card = 20 Or Card = 33 Or Card = 46 Then
ElseIf bytCurrentCard Mod 13 = Card Mod 13 Then
Else
Function = %False
End If
End Function
'--------------------------------------------------------------------------------

Sub TakeTurn(bytPlayer As Byte)
' Make the appropriate player take their turn
Local i As Long, PlayedCard As Long

' Uninvert all cards and disable "Play" button
Reset bytInvert()
Control Disable hDlgMain, %IDC_cmdPlay


' If it's player 1's turn, enable the "Pass" button
' otherwise, disable it
If bytPlayer = %Player1 Then
Control Enable hDlgMain, %IDC_cmdPass
Else
Control Disable hDlgMain, %IDC_cmdPass
End If

PlayedCard = %False
' If it's not player 1's turn, make the appropriate
' computer player play a card
If bytPlayerTurn <> %Player1 Then
' Pause for a bit
Sleep 450

' Scan through the player's cards
For i = 0 To UBound(bytCard)
' Check if any cards are playable
If bytCard(i) = bytPlayerTurn And ValidPlay(i) Then
PlayCard i
PlayedCard = %True
Exit For
End If
Next
If PlayedCard = %False Then
MustDraw = %TRUE
' Since no cards were playable, pass
PassTurn bytPlayerTurn
Else
MustDraw = %FALSE
End If
End If
Repaint
End Sub
'--------------------------------------------------------------------------------

Sub PassTurn(bytPlayer As Byte)
Local i As Long, FoundCard As Long
' Since a player elected to pass, give them an extra card
Incr NumCards(bytPlayer - 1)

' See if there are still cards in the deck
Array Scan deck(), =>0, To FoundCard
' If the deck is empty, get cards from discard pile and reshuffle
' them, but leave the top card of the discard pile in place
If IsFalse FoundCard Then
For i = 0 To UBound(bytCard)
If bytCard(i) = %Discard And i <> Discard Then
bytCard(i) = %Deck
deck(FoundCard) = i ' Assign discards to empty deck
Incr FoundCard
End If
Next
' See if there was more than one card in the discard pile. If not,
' since deck is now used up too, current player can no longer play;
' so play MUST pass to next player. This should happen rarely.
If FoundCard Then
Shuffle deck()
Else
MustDraw = %FALSE
wMsgBox "Player" & Str$(bytPlayerTurn) & " can't play and must pass.", "Empty Deck!"
End If
End If
' Get a card from the deck
If FoundCard Then bytCard(GetCard()) = bytPlayer

Repaint

If IsFalse MustDraw Then
' Increment turns
If bytPlayerTurn < %NumPlayers Then
Incr bytPlayerTurn
Else
bytPlayerTurn = %Player1
End If
End If
TakeTurn bytPlayerTurn
End Sub
'--------------------------------------------------------------------------------

Sub Deal()
Local i As Long, j As Long

' Disable the "Options" menu function
Menu Set State hMenu, ByCmd %IDM_FileOptions, %MF_GRAYED
' Hide the computer players' cards
ShowCards = %False

' Add one to the games total
Incr Games

' Game on!
GameOn = %True

' Replace all of the cards in the deck
Reset bytCard()

' Un-invert all cards
Reset bytInvert()

' Set the initial number of cards for each player
For i = 0 To %NumPlayers - 1 : NumCards(i) = StartCards : Next 'i

' Disable the buttons
Control Disable hDlgMain, %IDC_cmdPlay
Control Disable hDlgMain, %IDC_cmdPass

' Assign card values from 0 -> 51.
For i = 0 To UBound(deck) : deck(i) = i : Next
Shuffle deck()
bytCurrentCard = GetCard() ' Set the initial card
bytCurrentSuit = GetSuit(CLng (bytCurrentCard)) ' Set the initial suit
Discard = bytCurrentCard ' Set the top visible discard card
bytCard(CLng(bytCurrentCard)) = %Discard ' Assign it to discard pile
' Step through each player
For i = 1 To %NumPlayers
' Give each an appropriate number of random cards
For j = 1 To StartCards
' Assign a card to the player
bytCard(GetCard()) = i
Next 'j
Next 'i

' Find out which player dealt, and give them their turn
bytPlayerTurn = (Games Mod %NumPlayers) + 1
TakeTurn bytPlayerTurn
End Sub
'--------------------------------------------------------------------------------

Sub ResetGame()
' Reset the game data

Menu Set State hMenu, ByCmd %IDM_FileOptions, %MF_ENABLED
Dialog Set Text hDlgMain, "Crazy Eights"
Control Disable hDlgMain, %IDC_cmdPlay
Control Disable hDlgMain, %IDC_cmdPass
Reset Player1Score
Reset Player2Score
Reset Player3Score
Reset Player4Score

bytPlayerTurn = 1 ' Set to player 1's turn to start
Games = -1 ' No games have yet been played
GameOn = %False ' Game is over

' Clear game table
Repaint
End Sub
'--------------------------------------------------------------------------------
Function GetSuit(Card As Long) As Byte
' Find and return the suit of a given card
Select Case Card
Case 0 To 12
Function = %Clubs
Case 13 To 25
Function = %Diamonds
Case 26 To 38
Function = %Hearts
Case 39 To 51
Function = %Spades
End Select 'Card
End Function
'--------------------------------------------------------------------------------

Sub PlayCard(Card As Long)
' Place the indicated card on the discard pile, and
' take any other appropriate action
Local Rslt As Long

' Player now has one less card
Decr NumCards(bytCard(Card) - 1)

' Place the card on the discard pile
bytCard(Card) = %Discard
Discard = Card

Repaint

' Check for victory conditions
Array Scan NumCards(), =0, To Rslt
If Rslt Then
' Show everyone's cards
ShowCards = %True

Sleep 750 ' Pause to show empty player hand, then...
Repaint

' Tell the player who won
wMsgBox "Player" & Str$(bytPlayerTurn) & " wins this round.", "Round Over"

' Add up the cards remaining in the losers' hands
AddScores

' Show the scores
ShowfrmScore hDlgMain

' If someone won, announce it - else deal the next hand
If Max&(Player1Score, Player2Score, Player3Score, Player4Score) => MaxScore Then
If Player1Score < Min&(Player2Score, Player3Score, Player4Score) Then
wMsgBox "Player 1 wins the game!", "Winner!"
ResetGame
ElseIf Player2Score < Min&(Player1Score, Player3Score, Player4Score) Then
wMsgBox "Player 2 wins the game!", "Winner!"
ResetGame
ElseIf Player3Score < Min&(Player1Score, Player2Score, Player4Score) Then
wMsgBox "Player 3 wins the game!", "Winner!"
ResetGame
ElseIf Player4Score < Min&(Player1Score, Player2Score, Player3Score) Then
wMsgBox "Player 4 wins the game!", "Winner!"
ResetGame
Else
wMsgBox "We have a tie! Play another round.", "Tie!"
Deal
End If
Else
Deal
End If

Exit Sub
End If

' Set the current card data
bytCurrentCard = Card
bytCurrentSuit = GetSuit(Card)

' If it was an eight...
If Card = 7 Or Card = 20 Or Card = 33 Or Card = 46 Then
' If a computer player played it...
If bytPlayerTurn <> %Player1 Then
' Find a suit to change to that has the most cards in it.
' This is the only part of the game that has any kind of
' strategy to it.
bytCurrentSuit = GreatestSuit()

' Inform the user that the suit has changed
Select Case bytCurrentSuit
Case %Clubs
s$ = "Clubs."
Case %Diamonds
s$ = "Diamonds."
Case %Hearts
s$ = "Hearts."
Case %Spades
s$ = "Spades."
End Select 'bytCurrentSuit
wMsgBox "An Eight has been played, suit is now " & s$, "Suit Change"
Else ' Player1 played it...
' Make player1 select a new suit
ShowfrmNominate hDlgMain
End If
End If

' Un-invert the card
Reset bytInvert(Card)

' Increment turns
If bytPlayerTurn < %NumPlayers Then
Incr bytPlayerTurn
Else
bytPlayerTurn = %Player1
End If
TakeTurn bytPlayerTurn
End Sub
'--------------------------------------------------------------------------------
'--------------------------------------------------------------------------------
' ** CallBacks **
'--------------------------------------------------------------------------------
CallBack Function About_DLGPROC
Select Case CbMsg
Case %WM_COMMAND
Select Case CbCtl
Case %IDOK
Dialog End CbHndl
End Select ' CBCTL

Case %WM_INITDIALOG
Local ms As MEMORYSTATUS, r As RECT
Static Count&

hDC& = GetDC(%HWND_DESKTOP)
PointSize& = -(18 * GetDeviceCaps(hDC&, %LOGPIXELSY)) \ 72
ReleaseDC %HWND_DESKTOP, hDC&
hF& = CreateFont(PointSize&, 0, 0, 0, %FW_BOLD, %TRUE, %FALSE, %FALSE, _
%DEFAULT_CHARSET, %OUT_TT_PRECIS, %CLIP_DEFAULT_PRECIS, _
%DEFAULT_QUALITY, %FF_DONTCARE, "Times New Roman")
Control Send CbHndl, %IDC_LABELNIC, %WM_SETFONT, hF&, %TRUE

ms.dwLength = Len(ms)
GlobalMemoryStatus ms
Control Set Text CbHndl, %IDC_LABELMEM, Format$(ms.dwAvailPhys \ 1000) & " KB"

#If %IsXP = %FALSE
' Try to load the free resources DLL
' lResult& = GetFreeResources(0)
' IF lResult& THEN
' CONTROL SET TEXT CBHNDL, %IDC_LABELRES, Format$(lResult&) & "%"
' ELSE ' Free resources DLL failed, so just report memory load instead
#EndIf
Control Set Text CbHndl, %IDC_SLABELRES, "Memory In Use:"
Control Set Text CbHndl, %IDC_LABELRES, Format$(ms.dwMemoryLoad) & "%"
#If %IsXP = %FALSE
' END IF
#EndIf
SetTimer CbHndl, %IDT_TIMER3, 40, ByVal %NULL
Exit Function

Case %WM_CTLCOLORSTATIC
Select Case GetWindowLong(CbLParam, %GWL_ID)
Case %IDC_LABELNIC, %IDC_SLABELMEM, %IDC_SLABELRES
' Set Foreground color
SetTextColor CbWParam, %Blue
SetBkMode CbWParam, %TRANSPARENT
Function = GetStockObject(%NULL_BRUSH)
Exit Function
End Select

Case %WM_SIZE
' Center the dialog in parent's client area
Local p As POINTAPI, rc As RECT, w As Long, h As Long

GetClientRect GetParent(CbHndl), r
ClientToScreen GetParent(CbHndl), p
GetWindowRect CbHndl, rc
w = rc.nRight - rc.nLeft : h = rc.nBottom - rc.nTop
MoveWindow CbHndl, (r.nRight - w) \ 2 + p.x, (r.nBottom - h) \ 2 + p.y, w, h, %FALSE
Exit Function

Case %WM_TIMER
Select Case CbWParam
Case %IDT_TIMER3
Dialog Get User CbHndl, 1 To hCtl&
GetWindowRect hCtl&, r : h& = r.nBottom - r.nTop
MoveWindow hCtl&, 3, h& - Count&, r.nRight-r.nLeft, h&, %TRUE
Incr Count&
If Count& = h& * 2 Then Count& = 0 ' If desired, kill timer here for scroll stop
Exit Function
End Select

Case %WM_DESTROY
Count& = 0
KillTimer CbHndl, %IDT_TIMER3
DeleteObject hF&
End Select ' CBMSG
End Function
'------------------------------------------------------------------------------

CallBack Function ShowfrmOptionsProc()
Local txt As String, Index As Long

Select Case CbMsg
Case %WM_INITDIALOG
InitComboBox CbHndl, %IDC_COMBOBOX1, 30
ComboBox Select CbHndl, %IDC_COMBOBOX1, 1 + BackFace - %ordCrossHatch
txt = Format$(StartCards)
Control Set Text CbHndl, %IDC_TEXTBOX1, txt
txt = Format$(MaxScore)
Control Set Text CbHndl, %IDC_TEXTBOX2, txt

Case %WM_COMMAND
Select Case CbCtl
Case %IDOK
' Set the back of the card
Index = SendDlgItemMessage(CbHndl, %IDC_COMBOBOX1, %CB_GETCURSEL, 0, 0)
BackFace = %ordCrossHatch + Index

' Games go up to 100 to start
Control Get Text CbHndl, %IDC_TEXTBOX1 To txt
StartCards = Val(txt)
If StartCards < 5 Or StartCards > 10 Then
wMsgBox "Please enter a number between 5 and 10 for 'Cards Per Player'", "Invalid Input"
Exit Function
End If

' Players start off with 5 cards
Control Get Text CbHndl, %IDC_TEXTBOX2 To txt
MaxScore = Val(txt)
If MaxScore < 1 Or MaxScore > 1000 Then
wMsgBox "Please enter a number between 1 and 1000 for 'Game Ends At'", "Invalid Input"
Exit Function
End If
Dialog End CbHndl

Case %IDCANCEL
If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then Dialog End CbHndl
End Select 'CbCtl
End Select 'CbMsg
End Function
'--------------------------------------------------------------------------------

CallBack Function ShowfrmNominateProc()
Select Case CbMsg
Case %WM_INITDIALOG
Control Set Option CbHndl, %IDC_OPTION1, %IDC_OPTION1, %IDC_OPTION4
#If %IsXP = %FALSE
' Since Player1 played an 8, animate cards - if possible
Local FoundCard As Long

Select Case BackFace
Case %ordRobot, %ordCastle, %ordBeach, %ordCardHand
' Be sure there are still cards in the deck
Array Scan deck(), =>0, To FoundCard
' If not, don't animate
If FoundCard Then SetTimer CbHndl, %IDT_TIMER1, 250, ByVal %NULL
End Select 'BackFace

Case %WM_TIMER
Select Case CbWParam
Case %IDT_TIMER1
Static m_AnimationFrame As Long
Local TableDC As Dword

' Animate the deck cardback
TableDC = GetDC(hDlgMain)
lReturnValue& = cdtAnimate(TableDC, BackFace, %DeckX - (cWidth / 2), %DeckY - (cHeight / 2), m_AnimationFrame)
ReleaseDC hDlgMain, TableDC
Incr m_AnimationFrame
If lReturnValue& = 0 Then KillTimer CbHndl, %IDT_TIMER1 : Reset m_AnimationFrame
End Select 'CBWPARAM
Exit Function
#EndIf

Case %WM_COMMAND
Select Case CbCtl
Case %IDC_OPTION1
bytCurrentSuit = %Clubs
Case %IDC_OPTION2
bytCurrentSuit = %Diamonds
Case %IDC_OPTION3
bytCurrentSuit = %Hearts
Case %IDC_OPTION4
bytCurrentSuit = %Spades
Case %IDOK
If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
' Check default suit
Control Get Check CbHndl, %IDC_OPTION1 To lResult&
If lResult& Then bytCurrentSuit = %Clubs

#If %IsXP = %FALSE
' If card is still being animated, kill animation
If m_AnimationFrame Then KillTimer CbHndl, %IDT_TIMER1 : Reset m_AnimationFrame
#EndIf
Dialog End CbHndl
End If
End Select 'CbCtl
End Select 'CbMsg
End Function
'--------------------------------------------------------------------------------

CallBack Function ShowfrmScoreProc()
Local es As String

Select Case CbMsg
Case %WM_INITDIALOG
es = " /" & Str$(MaxScore)
'Show the scores
Control Set Text CbHndl, %IDC_LABEL5, Str$(Player1Score) & es
Control Set Text CbHndl, %IDC_LABEL6, Str$(Player2Score) & es
Control Set Text CbHndl, %IDC_LABEL7, Str$(Player3Score) & es
Control Set Text CbHndl, %IDC_LABEL8, Str$(Player4Score) & es

Case %WM_COMMAND
Select Case CbCtl
Case %IDOK
If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then Dialog End CbHndl
End Select 'CbCtl
End Select 'CbMsg
End Function
'--------------------------------------------------------------------------------

CallBack Function ShowDIALOG1Proc()
Local r As rect
Static hBrush As Dword, hBitMap As Dword, hdcCanvas As Dword, TableDC As Dword

Select Case CbMsg
Case %WM_INITDIALOG
Dim bytCard(51) ' Describes the owner/status of each card in the deck
Dim bytInvert(51) ' Determines which card(s) are currently highlighted (inverted)
Dim deck(51) ' Contains randomly shuffled cards
Dim NumCards(%NumPlayers - 1) ' Contains how many cards the players currently have

' DIALOG SET ICON cbhndl, "eights"

' Initialize the card dll
cdtInit cWidth, cHeight

' Set the back of the card
BackFace = %ordBeach

' Set it to player 1's turn to start
bytPlayerTurn = 1

' No games have yet been played
Games = -1

' Games go up to 100 to start
MaxScore = 100

' Players start off with 5 cards
StartCards = 5

' No game is active at startup
GameOn = %False

GetClientRect CbHndl, r

' Create double buffers
TableDC = GetDC(CbHndl)
hdcCanvas = CreateCompatibleDC(TableDC)
hBitMap = CreateCompatibleBitmap(TableDC, r.nRight, r.nBottom)
SelectObject hdcCanvas, hBitMap

' Cardtable green bitmap brush
hBrush = CreateSolidBrush(RGB(0, 128, 0))
SelectObject hdcCanvas, hBrush

Case %WM_COMMAND
Select Case CbCtl
Case %IDC_cmdPlay
If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
Dim i As Long, Rslt As Long

MustDraw = %FALSE

' Find the selected card and play it
Array Scan bytInvert(), =%ordInvert, To Rslt
If Rslt Then
PlayCard Rslt - 1
Exit Function
End If
End If
Exit Function

Case %IDC_cmdPass
If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then
MustDraw = %TRUE
PassTurn %Player1 ' The player has passed their turn
End If
Exit Function

Case %IDM_FileNew
' Reset and start again
ResetGame
Deal
Exit Function

Case %IDM_FileOptions
ShowfrmOptions CbHndl
If IsFalse GameOn Then Repaint
Exit Function

Case %IDM_FileScore
ShowfrmScore CbHndl
If IsFalse GameOn Then Repaint
Exit Function

Case %IDM_FileExit
Dialog End CbHndl
Exit Function

Case %IDM_HelpRules
wMsgBox "The game begins with one card in the discard pile. After this, cards may" + $CrLf + _
"only be played if they are of the same suit or they are the same value" + $CrLf + _
"as the card currently on the top of the discard pile. After a player takes" + $CrLf + _
"his turn, play continues in a clockwise fasion. An Eight may be played" + $CrLf + _
"on any turn and the player who plays the Eight must nominate a new suit." + $CrLf + _
"The next card played must be of the nominated suit, or another Eight. On any" + $CrLf + _
"turn, a player may choose to Pass instead of playing a card. This requires the" + $CrLf + _
"player to draw one new card. Cards must be drawn until play can continue. Play" + $CrLf + _
"continues in this fashion until a player is rid of all of his cards. At this" + $CrLf + _
"point, the round is over and scores are added up. The cards remaining in the" + $CrLf + _
"losers' hands are totalled: An Eight is worth 50 points, face cards are worth" + $CrLf + _
"10, all other cards are taken at face value (aces worth one). The first player" + $CrLf + _
"to play in each round is rotated in a clockwise fashion. As many rounds as" + $CrLf + _
"needed are played until one player breaks the maximum point total (default is" + $CrLf + _
"100) at which point the player with the lowest point total is declared the winner.", "How To Play Crazy Eights"
If IsFalse GameOn Then Repaint
Exit Function

Case %IDM_HelpAbout
ShowDialog_About CbHndl
Exit Function
End Select 'CBCTL

Case %WM_LBUTTONDOWN, %WM_LBUTTONDBLCLK
Local Card As Long

'Determine which card was selected and invert it

Card = -1 ' Initially set to: No card selected

'Set up the starting X, Y for each player's cards
Player1CardX = %Player1XMid - (cWidth + %CardOffsetX * (NumCards(0) - 1)) / 2
Player1CardY = %Player1YMid - (cHeight) / 2
Player3CardX = %Player3XMid - (cWidth + %CardOffsetX * (NumCards(2) - 1)) / 2
Player3CardY = %Player3YMid - (cHeight) / 2
Player2CardX = %Player2XMid - (cWidth) / 2
Player2CardY = %Player2YMid - (cHeight + %CardOffsetY * (NumCards(1) - 1)) / 2
Player4CardX = %Player4XMid - (cWidth) / 2
Player4CardY = %Player4YMid - (cHeight + %CardOffsetY * (NumCards(3) - 1)) / 2

' Step through each card
For i = 0 To UBound(bytCard)
' Clear any previous inverts
bytInvert(i) = %ordFaces

' If the card belongs to player1...
If bytCard(i) = %Player1 Then
' check if it's been clicked
If (LoWrd(CbLParam) >= Player1CardX) And (LoWrd(CbLParam) <= Player1CardX + cWidth) And _
(HiWrd(CbLParam) >= Player1CardY) And (HiWrd(CbLParam) <= Player1CardY + cHeight) Then Card = i
Player1CardX = Player1CardX + %CardOffsetX
End If
Next

If Card <> -1 And bytPlayerTurn = %Player1 Then
' If a card was clicked, and it's the first player's turn..
' Invert the card
bytInvert(Card) = %ordInvert

'If the card is a valid card (for play) then enable the button
If ValidPlay(Card) Then
Control Enable hDlgMain, %IDC_cmdPlay
If CbMsg = %WM_LBUTTONDBLCLK Then Control Post CbHndl, %IDC_cmdPlay, %BM_CLICK, 0, 0
Else
Control Disable hDlgMain, %IDC_cmdPlay
End If
Else ' clear all inverted cards
Reset bytInvert()

' Disable the play button
Control Disable hDlgMain, %IDC_cmdPlay
End If

' Redisplay
Repaint
Function = 1 : Exit Function

Case %WM_PAINT
' Clear the table
GetClientRect CbHndl, r
FillRect hdcCanvas, r, hBrush

' If there's no game, don't draw cards
If GameOn Then PaintCards hdcCanvas

' Paint the canvas on the playing table
BitBlt TableDC, 0, 0, r.nRight - 1, r.nBottom - 1, hdcCanvas, 0, 0, %SRCCOPY
Exit Function

Case %WM_MOVE
Repaint

Case %WM_DESTROY
'Allow the card dll to terminate
cdtTerm
DeleteObject hBrush
DeleteObject hBitMap
DeleteDC hdcCanvas
ReleaseDC CbHndl, TableDC
End Select 'CBMSG
End Function
'--------------------------------------------------------------------------------
' ** Dialogs **
'--------------------------------------------------------------------------------
Function ShowDialog_About(ByVal hParent As Dword) As Long
Local lRslt As Long
#PBForms Begin Dialog %IDD_frmAbout->->
Local hDlg As Dword, hChild As Dword

Dialog New hParent, "About Crazy Eights", 0, 0, 187, 147, _
%WS_POPUP Or %DS_MODALFRAME Or %WS_CAPTION Or %DS_3DLOOK Or %DS_CENTER, 0 To hDlg

Text$ = """Money ain't for nuthin', get yer chicks for free"""
Text$ = Text$ & $CrLf & $CrLf & $CrLf & "A good old game of classic Crazy Eights. The computer players aren't too sly, so take it easy on them, eh?"
Text$ = Text$ & $CrLf & $CrLf & $CrLf & "Released to Public Domain 2004, Melnick-Nax"


Control Add Button, hDlg, %IDOK, "&OK", 160, 6, 21, 20, _
%WS_CHILD Or %WS_VISIBLE Or %BS_PUSHBUTTON Or %WS_TABSTOP Or %BS_DEFAULT

Control Add Label, hDlg, %IDC_LABELNIC, "Built By PB...", 43, 11, 103, 20
Control Add Label, hDlg, %IDC_SLABELMEM, "Free Memory:", 16, 115, 50, 16
Control Add Label, hDlg, %IDC_SLABELRES, "System Resources:", 16, 130, 65, 16
Control Add Label, hDlg, %IDC_LABELMEM, "0", 80, 115, 80, 16
Control Add Label, hDlg, %IDC_LABELRES, "0", 80, 130, 80, 16

' We need a no-frills dialog container for text clipping
Dialog New hDlg, "", 16, 34, 152, 74, %WS_CHILD, 0 To hChild

' Surround it with a static etched frame for "the look"
CreateWindowEx %WS_EX_CLIENTEDGE Or %WS_EX_NOPARENTNOTIFY, "STATIC" & Chr$(0), Chr$(0), _
%WS_CHILD Or %WS_VISIBLE Or %SS_ETCHEDFRAME, _
22, 53, 232, 126, hDlg, -1, GetWindowLong(hDlg, %GWL_HINSTANCE), ByVal %NULL

' Place the info label location below the dialog so it is clipped from view
Control Add Label, hChild, %IDC_INFO, Text$, 3, 74, 148, 72, %SS_CENTER ',%WS_EX_STATICEDGE *use for adjustment*

' Give info label desired font
Control Handle hChild, %IDC_INFO To hCtl&
SendMessage hCtl&, %WM_SETFONT, GetStockObject(%ANSI_VAR_FONT), 0

' Add program Icon
' CONTROL ADD IMAGEX, hDlg, %IDC_IMAGEX6, "eights", 5, 5, 21, 20, _
' %WS_CHILD OR %WS_VISIBLE OR %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN

#PBForms End Dialog

Dialog Set User hDlg, 1, hCtl&
ShowWindow hChild, %SW_SHOW
Dialog Show Modal hDlg, Call About_DLGPROC To lRslt

Function = lRslt
End Function
'------------------------------------------------------------------------------
Function ShowfrmOptions(ByVal hParent As Dword) As Long
Local lRslt As Long
#PBForms Begin Dialog %IDD_frmOptions->->
Local hDlg As Dword
Dialog New hParent, "Options", 60, 20, 121, 93, %WS_POPUP Or %WS_BORDER Or _
%WS_DLGFRAME Or %WS_SYSMENU Or %WS_CLIPSIBLINGS Or %WS_VISIBLE Or _
%DS_MODALFRAME Or %DS_3DLOOK Or %DS_NOFAILCREATE Or %DS_SETFONT, _
%WS_EX_WINDOWEDGE Or %WS_EX_CONTROLPARENT Or %WS_EX_LEFT Or _
%WS_EX_LTRREADING Or %WS_EX_RIGHTSCROLLBAR, To hDlg
Control Add Label, hDlg, %NULL, "Cards Per Player:", 5, 10, 55, 10
Control Add Label, hDlg, %NULL, "Game Ends At:", 5, 25, 55, 10
Control Add Label, hDlg, %NULL, "Card Style: ", 5, 41, 45, 9
Control Add ComboBox, hDlg, %IDC_COMBOBOX1, , 65, 40, 50, 50, %WS_VSCROLL Or %CBS_DROPDOWNLIST
Control Add Button, hDlg, %IDCANCEL, "&Cancel", 3, 75, 45, 12
Control Add Button, hDlg, %IDOK, "&Set Options", 3, 58, 45, 12, %BS_CENTER Or _
%BS_VCENTER Or %WS_TABSTOP Or %BS_DEFAULT Or %WS_VISIBLE
Control Add TextBox, hDlg, %IDC_TEXTBOX1, "5", 65, 10, 35, 10
Control Add TextBox, hDlg, %IDC_TEXTBOX2, "100", 65, 24, 35, 10
#PBForms End Dialog
Dialog Show Modal hDlg, Call ShowfrmOptionsProc To lRslt
Function = lRslt
End Function
'--------------------------------------------------------------------------------
Function ShowfrmNominate(ByVal hParent As Dword) As Long
Local lRslt As Long
#PBForms Begin Dialog %IDD_frmNominate->->
Local hDlg As Dword
Dialog New hParent, "Nominate Suit", 29, 95, 116, 48, %WS_POPUP Or _
%WS_BORDER Or %WS_DLGFRAME Or %WS_SYSMENU Or %WS_CLIPSIBLINGS Or _
%WS_VISIBLE Or %DS_MODALFRAME Or %DS_3DLOOK Or %DS_NOFAILCREATE Or _
%DS_SETFONT, %WS_EX_WINDOWEDGE Or %WS_EX_CONTROLPARENT Or %WS_EX_LEFT Or _
%WS_EX_LTRREADING Or %WS_EX_RIGHTSCROLLBAR, To hDlg
Control Add Option, hDlg, %IDC_OPTION1, "Clubs", 10, 5, 44, 10, %WS_GROUP
Control Add Option, hDlg, %IDC_OPTION2, "Diamonds", 10, 15, 44, 10
Control Add Option, hDlg, %IDC_OPTION3, "Hearts", 60, 5, 44, 10
Control Add Option, hDlg, %IDC_OPTION4, "Spades", 60, 15, 44, 10
Control Add Button, hDlg, %IDOK, "Select Suit", 5, 30, 105, 15, %WS_CHILD Or _
%WS_VISIBLE Or %WS_TABSTOP Or %BS_TEXT Or %BS_PUSHBUTTON Or _
%BS_DEFPUSHBUTTON Or %BS_CENTER Or %BS_VCENTER Or %WS_GROUP Or %BS_DEFAULT, _
%WS_EX_LEFT Or %WS_EX_LTRREADING
#PBForms End Dialog
Dialog Show Modal hDlg, Call ShowfrmNominateProc To lRslt
Function = lRslt
End Function
'--------------------------------------------------------------------------------
Function ShowfrmScore(ByVal hParent As Dword) As Long
Local lRslt As Long
#PBForms Begin Dialog %IDD_frmScore->->
Local hDlg As Dword
Dialog New hParent, "Scores", 65, 95, 75, 68, %WS_POPUP Or %WS_BORDER Or _
%WS_DLGFRAME Or %WS_CAPTION Or %WS_SYSMENU Or %WS_VISIBLE Or _
%DS_MODALFRAME Or %DS_3DLOOK Or %DS_NOFAILCREATE Or %DS_SETFONT, _
%WS_EX_WINDOWEDGE Or %WS_EX_CONTROLPARENT Or %WS_EX_LEFT Or _
%WS_EX_LTRREADING Or %WS_EX_RIGHTSCROLLBAR, To hDlg
Control Add Label, hDlg, %NULL, "Player 1:", 0, 5, 30, 10
Control Add Label, hDlg, %NULL, "Player 2:", 0, 15, 30, 10
Control Add Label, hDlg, %NULL, "Player 3:", 0, 25, 30, 10
Control Add Label, hDlg, %NULL, "Player 4:", 0, 35, 30, 10
Control Add Label, hDlg, %IDC_LABEL5, "0", 30, 5, 40, 10, %WS_CHILD Or _
%WS_VISIBLE Or %SS_LEFT, %WS_EX_RIGHT Or %WS_EX_LTRREADING
Control Add Label, hDlg, %IDC_LABEL6, "0", 30, 15, 40, 10, %WS_CHILD Or _
%WS_VISIBLE Or %SS_LEFT, %WS_EX_RIGHT Or %WS_EX_LTRREADING
Control Add Label, hDlg, %IDC_LABEL7, "0", 30, 25, 40, 10, %WS_CHILD Or _
%WS_VISIBLE Or %SS_LEFT, %WS_EX_RIGHT Or %WS_EX_LTRREADING
Control Add Label, hDlg, %IDC_LABEL8, "0", 30, 35, 40, 10, %WS_CHILD Or _
%WS_VISIBLE Or %SS_LEFT, %WS_EX_RIGHT Or %WS_EX_LTRREADING
Control Add Button, hDlg, %IDOK, "&OK", 5, 50, 60, 15, %BS_DEFAULT
#PBForms End Dialog
Dialog Show Modal hDlg, Call ShowfrmScoreProc To lRslt
Function = lRslt
End Function
'--------------------------------------------------------------------------------
Function ShowDIALOG1(ByVal hParent As Dword) As Long
Local lRslt As Long
#PBForms Begin Dialog %IDD_DIALOG1->%IDR_MENU1->%IDR_ACCELERATOR1
Dialog New hParent, "Crazy Eights", 387, 162, 400, 258, %WS_POPUP Or _
%WS_BORDER Or %WS_DLGFRAME Or %WS_CAPTION Or %WS_SYSMENU Or _
%WS_CLIPSIBLINGS Or %WS_VISIBLE Or %DS_CENTER Or %DS_NOFAILCREATE Or _
%DS_3DLOOK Or %DS_SETFONT Or %WS_MINIMIZEBOX, %WS_EX_LEFT Or _
%WS_EX_LTRREADING, To hDlgMain
Dialog Set Color hDlgMain, -1, RGB(0, 128, 0)
Control Add Button, hDlgMain, %IDC_cmdPlay, "&Play Card", 150, 158, 50, 15, %WS_DISABLED
Control Add Button, hDlgMain, %IDC_cmdPass, "Pass (&Draw)", 202, 158, 50, 15, %WS_DISABLED
AttachMENU1 hDlgMain
AttachACCELERATOR1 hDlgMain
#PBForms End Dialog
Dialog Show Modal hDlgMain, Call ShowDIALOG1Proc To lRslt
Function = lRslt
End Function
'--------------------------------------------------------------------------------
'--------------------------------------------------------------------------------
' ** Accelerators **
'--------------------------------------------------------------------------------
#PBForms Begin AssignAccel
Function AssignAccel(tAccel As ACCELAPI, ByVal wKey As Word, ByVal wCmd As Word, _
ByVal byFVirt As Byte) As Long
tAccel.fVirt = byFVirt
tAccel.key = wKey
tAccel.cmd = wCmd
End Function
#PBForms End AssignAccel
'--------------------------------------------------------------------------------
'--------------------------------------------------------------------------------
Function AttachACCELERATOR1(ByVal hDlg As Dword) As Dword
#PBForms Begin Accel %IDR_ACCELERATOR1->%IDD_DIALOG1
Local hAccel As Dword
Local tAccel() As ACCELAPI
Dim tAccel(1 To 1)
AssignAccel tAccel(1), %VK_F2, %IDM_FileNew, %FVIRTKEY Or %FNOINVERT
Accel Attach hDlg, tAccel() To hAccel
#PBForms End Accel
Function = hAccel
End Function
